# coding: utf-8

"""
    RentCast API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from rentcast_client.models.property_records200_response_inner_features import PropertyRecords200ResponseInnerFeatures
from rentcast_client.models.property_records200_response_inner_owner import PropertyRecords200ResponseInnerOwner
from rentcast_client.models.property_records200_response_inner_property_taxes import PropertyRecords200ResponseInnerPropertyTaxes
from rentcast_client.models.property_records200_response_inner_tax_assessments import PropertyRecords200ResponseInnerTaxAssessments
from typing import Optional, Set
from typing_extensions import Self

class PropertyRecords200ResponseInner(BaseModel):
    """
    PropertyRecords200ResponseInner
    """ # noqa: E501
    id: Optional[StrictStr] = None
    formatted_address: Optional[StrictStr] = Field(default=None, alias="formattedAddress")
    address_line1: Optional[StrictStr] = Field(default=None, alias="addressLine1")
    address_line2: Optional[Any] = Field(default=None, alias="addressLine2")
    city: Optional[StrictStr] = None
    state: Optional[StrictStr] = None
    zip_code: Optional[StrictStr] = Field(default=None, alias="zipCode")
    county: Optional[StrictStr] = None
    latitude: Optional[Union[StrictFloat, StrictInt]] = 0
    longitude: Optional[Union[StrictFloat, StrictInt]] = 0
    property_type: Optional[StrictStr] = Field(default=None, alias="propertyType")
    bedrooms: Optional[StrictInt] = 0
    bathrooms: Optional[StrictInt] = 0
    square_footage: Optional[StrictInt] = Field(default=0, alias="squareFootage")
    lot_size: Optional[StrictInt] = Field(default=0, alias="lotSize")
    year_built: Optional[StrictInt] = Field(default=0, alias="yearBuilt")
    assessor_id: Optional[StrictStr] = Field(default=None, alias="assessorID")
    legal_description: Optional[StrictStr] = Field(default=None, alias="legalDescription")
    subdivision: Optional[StrictStr] = None
    zoning: Optional[StrictStr] = None
    last_sale_date: Optional[StrictStr] = Field(default=None, alias="lastSaleDate")
    last_sale_price: Optional[StrictInt] = Field(default=0, alias="lastSalePrice")
    features: Optional[PropertyRecords200ResponseInnerFeatures] = None
    tax_assessments: Optional[PropertyRecords200ResponseInnerTaxAssessments] = Field(default=None, alias="taxAssessments")
    property_taxes: Optional[PropertyRecords200ResponseInnerPropertyTaxes] = Field(default=None, alias="propertyTaxes")
    owner: Optional[PropertyRecords200ResponseInnerOwner] = None
    owner_occupied: Optional[StrictBool] = Field(default=True, alias="ownerOccupied")
    __properties: ClassVar[List[str]] = ["id", "formattedAddress", "addressLine1", "addressLine2", "city", "state", "zipCode", "county", "latitude", "longitude", "propertyType", "bedrooms", "bathrooms", "squareFootage", "lotSize", "yearBuilt", "assessorID", "legalDescription", "subdivision", "zoning", "lastSaleDate", "lastSalePrice", "features", "taxAssessments", "propertyTaxes", "owner", "ownerOccupied"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PropertyRecords200ResponseInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of features
        if self.features:
            _dict['features'] = self.features.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tax_assessments
        if self.tax_assessments:
            _dict['taxAssessments'] = self.tax_assessments.to_dict()
        # override the default output from pydantic by calling `to_dict()` of property_taxes
        if self.property_taxes:
            _dict['propertyTaxes'] = self.property_taxes.to_dict()
        # override the default output from pydantic by calling `to_dict()` of owner
        if self.owner:
            _dict['owner'] = self.owner.to_dict()
        # set to None if address_line2 (nullable) is None
        # and model_fields_set contains the field
        if self.address_line2 is None and "address_line2" in self.model_fields_set:
            _dict['addressLine2'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PropertyRecords200ResponseInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "formattedAddress": obj.get("formattedAddress"),
            "addressLine1": obj.get("addressLine1"),
            "addressLine2": obj.get("addressLine2"),
            "city": obj.get("city"),
            "state": obj.get("state"),
            "zipCode": obj.get("zipCode"),
            "county": obj.get("county"),
            "latitude": obj.get("latitude") if obj.get("latitude") is not None else 0,
            "longitude": obj.get("longitude") if obj.get("longitude") is not None else 0,
            "propertyType": obj.get("propertyType"),
            "bedrooms": obj.get("bedrooms") if obj.get("bedrooms") is not None else 0,
            "bathrooms": obj.get("bathrooms") if obj.get("bathrooms") is not None else 0,
            "squareFootage": obj.get("squareFootage") if obj.get("squareFootage") is not None else 0,
            "lotSize": obj.get("lotSize") if obj.get("lotSize") is not None else 0,
            "yearBuilt": obj.get("yearBuilt") if obj.get("yearBuilt") is not None else 0,
            "assessorID": obj.get("assessorID"),
            "legalDescription": obj.get("legalDescription"),
            "subdivision": obj.get("subdivision"),
            "zoning": obj.get("zoning"),
            "lastSaleDate": obj.get("lastSaleDate"),
            "lastSalePrice": obj.get("lastSalePrice") if obj.get("lastSalePrice") is not None else 0,
            "features": PropertyRecords200ResponseInnerFeatures.from_dict(obj["features"]) if obj.get("features") is not None else None,
            "taxAssessments": PropertyRecords200ResponseInnerTaxAssessments.from_dict(obj["taxAssessments"]) if obj.get("taxAssessments") is not None else None,
            "propertyTaxes": PropertyRecords200ResponseInnerPropertyTaxes.from_dict(obj["propertyTaxes"]) if obj.get("propertyTaxes") is not None else None,
            "owner": PropertyRecords200ResponseInnerOwner.from_dict(obj["owner"]) if obj.get("owner") is not None else None,
            "ownerOccupied": obj.get("ownerOccupied") if obj.get("ownerOccupied") is not None else True
        })
        return _obj


